<?php
class RuscableRssReader
{
// default output settings
	var $charset  = "windows-1251";
	var $language = "ru_RU";

// default input settings
	var $channel  = "http://www.ruscable.ru/rss-news/export/news.xml";

// table for rfcdate2timestamp() function
	var $months = array(
		'Jan' => 1,
		'Feb' => 2,
		'Mar' => 3,
		'Apr' => 4,
		'May' => 5,
		'Jun' => 6,
		'Jul' => 7,
		'Aug' => 8,
		'Sep' => 9,
		'Oct' => 10,
		'Nov' => 11,
		'Dec' => 12
	);

// convert date in rfc2822 format (but support only 4-digit year) to unix timestamp
	function rfcdate2timestamp($rfc)
	{
		if( ! preg_match('{(\d{1,2})\s+(\w{3})\s+(\d{2,4})\s+(\d{1,2}):(\d{2}):(\d{2})\s+}', $rfc, $t) ) return time();
		return mktime($t[4], $t[5], $t[6], $this->months[$t[2]], $t[1], $t[3]);
	}

// convert DomNode (with children) to associative array
	function node2assoc($node, $convert_date = FALSE)
	{
		$ret_val = array();
		for($item = $node->first_child(); $item; $item = $item->next_sibling())
		{
			if( empty($item->tagname) ) continue;
			$child_nodes = $this->node2assoc($item, $convert_date);
			if( ! empty($child_nodes) )
			{
				$ret_val[$item->tagname][] = $child_nodes;
			}
			else
			{
				$ret_val[$item->tagname] = mb_convert_encoding($item->get_content(), $this->charset, 'UTF-8');
				if( $convert_date && strstr($item->tagname, 'Date') )
					$ret_val[$item->tagname] = $this->rfcdate2timestamp($ret_val[$item->tagname]);
			}
		}
		return $ret_val;
	}

// compare items by 'pubDate' field (reverse order)
	function cmp_by_date($item1, $item2)
	{
		return $item2['pubDate'] - $item1['pubDate'];
	}

// return some last items as array of associative arrays
	function get_last_items($n = FALSE)
	{
		$param = ( $n > 0 ) ? "?n=$n" : '';
		$xml_doc = @domxml_open_file($this->channel . $param);
		if( $xml_doc === FALSE ) return array();

		$rss = $xml_doc->document_element();
		$channels = $rss->get_elements_by_tagname('channel');
		$channel = $this->node2assoc($channels[0], TRUE); // now it a simple array
		usort($channel['item'], array(__CLASS__, 'cmp_by_date')); // optional
		return $channel['item'];
	}
}
?>